<div id="validationMessage" class="alert alert-warning" style="display: none"></div>

<form action="--to-be-updated--" method="POST" id="testDefForm">
  <fieldset class="container-fluid">
    <div class="float-right mt-2">
      <% if (test.fixed_questions===true && test.type_name !=='Peer assessment PHASE2 MASTER' ) { %>
        <button id="btnDeepClone" type="submit" title="Create a DEEP copy of the exam definition (also clones questions!)"
          class="btn btn-success btn-outline">Deep clone
        </button>
      <% } %>
      <button id="btnClone" type="submit" title="Create a copy of the exam definition (does not clone questions)"
        class="btn btn-success btn-outline">Clone
      </button>
      <button id="btnCloneUp" type="submit" title="Create a copy of the exam definition in the next academic year"
        class="btn btn-success btn-outline">Clone up
      </button>
      <button id="btnValidateTest" type="button"
        title="Test if the current exam definition generates exam instances that make sense"
        class="btn btn-success btn-outline">Validate
      </button>
      <button id="btnSaveTest" type="submit" name="savetest" value="savetest" class="btn btn-primary btn-outline">
        Save
      </button>
      <button id="btnTestGen" type="submit" name="testgen" value="testgen" class="btn btn-light btn-outline-dark">
        Test Generate
      </button>
    </div>
  </fieldset>
  <input type="hidden" id="id_test" name="id_test" value="<%= test.id %>" />
  <div class="container-fluid">
    <div class="card mt-2">
      <div class="card-header">
        <div class="row p-3">
          <div class="col-3">
            <h4 class="card-title">Exam definition</h4>
          </div>
          <div class="col-9 d-flex justify-content-end">
            <div class="d-flex justify-content-between flex-column">
              <span><b>Id:</b> <span class="badge badge-primary" style="font-size: 1.2rem;">
                  <%=test.id%>
                </span></span>
              <span><b>Type:</b>
                <%=test.type_name%>
              </span>
            </div>
            <div class="d-flex justify-content-between flex-column ml-3">
              <span><b>Created: </b>
                <%- test.first_name %>
                  <%- test.last_name %> (<%- test.ts_created %>)
              </span>
              <span><b>Modified: </b>
                <%- test.user_modified %> (<%- test.ts_modified %>)
              </span>
            </div>
          </div>
        </div>
      </div>
      <div class="card-body">
        <div class="row d-flex justify-content-between pl-2 pr-2">
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="test_ordinal">Ordinal</label>
              <input type="number" class="form-control" id="test_ordinal" name="test_ordinal"
                value="<%- test.test_ordinal %>" size="2" min="1" max="99">
            </fieldset>
          </div>
          <div class="flex-grow-1 mr-2">
            <fieldset class="form-group">
              <label for="title">Title</label>
              <input type="text" class="form-control" id="title" name="title" value="<%- test.title %>">
            </fieldset>
          </div>
          <div class="mr-2" style="max-width: 6rem;">
            <fieldset class="form-group">
              <label for="title_abbrev">Title abbrev</label>
              <input type="text" class="form-control" id="title_abbrev" name="title_abbrev"
                value="<%- test.title_abbrev %>">
            </fieldset>
          </div>
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="password">Password</label>
              <input type="text" class="form-control" id="password" name="password" value="<%- test.password %>">
            </fieldset>
          </div>
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="ts_available_from">Available from</label>
              <input required class="form-control" type="text" id="ts_available_from" name="ts_available_from"
                pattern="\d{4}-[01]\d-[0-3]\d\s[0-2]\d:[0-5]\d:[0-5]\d" value="<%- test.ts_available_from %>"
                </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="ts_available_to">Available to</label>
              <input required class="form-control" type="text" id="ts_available_to" name="ts_available_to"
                pattern="\d{4}-[01]\d-[0-3]\d\s[0-2]\d:[0-5]\d:[0-5]\d" value="<%- test.ts_available_to %>" </fieldset>
          </div>
        </div>
        <div class="row d-flex justify-content-between pl-2 pr-2">
              <div>
                <fieldset class="form-group">
                  <label for="is_global">Global</label>
                  <div id="is_global" title="Whether students can run test regardles of academic year">
                    <input class="form-control " type="checkbox" name="is_global" value="true" data-toggle="toggle" <%=(
                      (test.is_global) ? "checked" : "" ) %>>
                  </div>
                </fieldset>
              </div>
              <div>
                <fieldset class="form-group">
                  <label for="is_public">Public</label>
                  <div id="is_public" title="Whether to require password">
                    <input class="form-control " type="checkbox" name="is_public" value="true" data-toggle="toggle" <%=(
                      (test.is_public) ? "checked" : "" ) %>>
                  </div>
                </fieldset>
              </div>
              <div>
                <fieldset class="form-group">
                  <label for="use_in_stats">Use in stats</label>
                  <div id="use_in_stats"
                    title="Whether to include this test in statistics that are shown to the students">
                    <input class="form-control " type="checkbox" name="use_in_stats" value="true" data-toggle="toggle"
                      <%=( (test.use_in_stats) ? "checked" : "" ) %>>
                  </div>
                </fieldset>
              </div>
              <div>
                <fieldset class="form-group">
                  <label for="show_solutions">Show solutions</label>
                  <div id="show_solutions">
                    <input class="form-control " type="checkbox" name="show_solutions" value="true" data-toggle="toggle"
                      <%=( (test.show_solutions) ? "checked" : "" ) %>>
                  </div>
                </fieldset>
              </div>
              <div>
                <fieldset class="form-group">
                  <label for="hint_result" title="Kids Mode">Hint result</label>
                  <div id="hint_result">
                    <input class="form-control " type="checkbox" name="hint_result" value="true" data-toggle="toggle"
                      <%=( (test.hint_result===false) ? "" : "checked" ) %>>
                  </div>
                </fieldset>
              </div>
              <% if(test.fixed_questions===true) { %>
                <div>
                  <fieldset class="form-group">
                    <label for="is_competition">Competition</label>
                    <div id="is_competition">
                      <input id="is_competition_checkbox" class="form-control" type="checkbox" name="is_competition"
                        value="true" data-toggle="toggle" <%=( (test.is_competition===false) ? "" : "checked" ) %>>
                    </div>
                  </fieldset>
                </div>
                <% } %>
                  <div>
                    <fieldset class="form-group">
                      <label for="async_submit">Async submit</label>
                      <div id="async_submit">
                        <input class="form-control" type="checkbox" name="async_submit" value="true"
                          data-toggle="toggle" <%=( (test.async_submit===false) ? "" : "checked" ) %>>
                      </div>
                    </fieldset>
                  </div>
                  <div>
                    <fieldset class="form-group">
                      <label for="test_score_ignored">Score ignored</label>
                      <div id="test_score_ignored">
                        <input class="form-control" type="checkbox" name="test_score_ignored" value="true"
                          data-toggle="toggle" <%=( (test.test_score_ignored) ? "checked" : "" ) %>>
                      </div>
                    </fieldset>
                  </div>
                  <div>
                    <fieldset class="form-group">
                      <label for="forward_only">Forward only</label>
                      <div id="forward_only">
                        <input class="form-control" type="checkbox" name="forward_only" value="true"
                          data-toggle="toggle" <%=( (test.forward_only) ? "checked" : "" ) %>>
                      </div>
                    </fieldset>
                  </div>
                  <div>
                    <fieldset class="form-group">
                      <label for="allow_anonymous_stalk">Anon. stalk</label>
                      <div id="allow_anonymous_stalk">
                        <input class="form-control" type="checkbox" name="allow_anonymous_stalk" value="true"
                          data-toggle="toggle" <%=( (test.allow_anonymous_stalk) ? "checked" : "" ) %>>
                      </div>
                    </fieldset>
                  </div>
            <div>
              <fieldset class="form-group">
                <label for="trim_clock">Trim clock</label>
                <div id="trim_clock">
                  <input class="form-control" type="checkbox" name="trim_clock" value="true"
                    data-toggle="toggle" <%=((test.trim_clock) ? "checked" : "" ) %>>
                </div>
              </fieldset>
            </div>

        </div>
        <div class="row d-flex justify-content-between pl-2 pr-2">
          <div>
            <fieldset class="form-group">
              <label for="max_runs">Max runs</label>
              <input type="number" min="0" max="100000" class="form-control" id="max_runs" name="max_runs"
                value="<%- test.max_runs %>">
            </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="max_score">Max score</label>
              <input type="number" min="0.0" max="1000" step="0.01" class="form-control" id="max_score" name="max_score"
                value="<%- test.max_score %>">
            </fieldset>
          </div>

          <div>
            <fieldset class="form-group">
              <label for="questions_no">No of questions</label>
              <input type="number" min="1" max="1000" class="form-control" id="questions_no" name="questions_no"
                value="<%- test.questions_no %>">
            </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="duration_seconds">Duration (secs)</label>
              <input type="number" min="1" max="31536000" class="form-control" id="duration_seconds"
                name="duration_seconds" value="<%- test.duration_seconds %>">
            </fieldset>
          </div>

          <div>
            <fieldset class="form-group">
              <label for="pass_percentage">Pass perc</label>
              <input type="number" min="0" max="1" step="0.01" class="form-control" id="pass_percentage"
                name="pass_percentage" value="<%- test.pass_percentage %>">
            </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="review_period_mins">Rvw period (min)</label>
              <input type="number" min="0" class="form-control" id="review_period_mins" name="review_period_mins"
                value="<%- test.review_period_mins %>">
            </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="upload_file_no">Upload files</label>
              <input type="number" min="0" max="10" class="form-control" id="upload_file_no" name="upload_file_no"
                value="<%- test.upload_file_no %>">
            </fieldset>
          </div>
          <div>
            <fieldset class="form-group">
              <label for="upload_file_limit">Upload limit(B)</label>
              <input type="number" min="1" max="10485760 " class="form-control" id="upload_file_limit"
                name="upload_file_limit" value="<%- test.upload_file_limit %>">
            </fieldset>
          </div>
        </div>
        <div class="row d-flex justify-content-between flex-nowrap pl-2 pr-2">
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="id_pace_question">Question pace</label>
              <div id="id_pace_question">
                <% locals.combodata={ id: "id_pace_question" , list: pace_schemes, name: "id_pace_question" ,
                            selected: test.id_pace_question }; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
              </div>
            </fieldset>
          </div>
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="id_pace_test">Test pace</label>
              <div id="id_pace_test">
                <% locals.combodata={ id: "id_pace_test" , list: pace_schemes, name: "id_pace_test" , selected:
                            test.id_pace_test }; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
              </div>
            </fieldset>
          </div>
          <div class="mr-2">
            <fieldset class="form-group">
              <label for="id_ticket_policy">Ticket policy</label>
              <div id="id_ticket_policy">
                <% locals.combodata={ id: "id_ticket_policy" , list: ticket_policies,
                            name: "id_ticket_policy" , selected: test.id_ticket_policy }; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
              </div>
            </fieldset>
          </div>

          <div class="mr-2">
            <fieldset class="form-group">
              <label for="id_email_reminder_scheme">Email reminder</label>
              <div id="id_email_reminder_scheme">
                <% locals.combodata={ id: "id_email_reminder_scheme" , list: email_reminder_schemes,
                            name: "id_email_reminder_scheme" , selected: test.id_email_reminder_scheme }; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
              </div>
            </fieldset>
          </div>

          <div>
            <fieldset class="form-group">
              <label for="id_plag_method">RT plag detection</label>
              <div id="id_plag_method">
                <% locals.combodata={id: "id_plag_detection_algorithm" , class: "form-control" , list: tests, name:"id_plag_detection_algorithm", selected: test.id_plag_detection_algorithm} %>
                <%- include(`${locals.partialsRoot}/combo`) %>
              </div>
            </fieldset>
          </div>




        </div>


      </div>
    </div>
  </div>
  <% if (test.type_name==='Peer assessment PHASE2 MASTER' ) { %>
    <div id="peer21">
      <%- include(`./editPeerPhase2DefView1`) %>
    </div>
    <% } %>
      <% if (test.fixed_questions===true && test.type_name !=='Peer assessment PHASE2 MASTER' ) { %>
        <div id="eval_comp_score" class="<%- test.is_competition === true ? '' : 'hidden'%>">
          <div class="container-fluid">
            <div class="card card-body">
              <div class="form-group">
                <label for="exampleInputEmail1">Scoring formula</label>
                <i class="fas fa-info-circle" tabindex="-1" data-trigger="focus" data-toggle="popover" title="Usage"
                  data-content="Write your scoring formula, allowed symbols are: numbers[0-9], basic operators[+-*/%^],
                           braces(), brackets[] and all Math utilities (eg. Math.E, Math.sqrt, Math.pow, ...)"></i>
                <input value="<%- test.eval_comp_score || '[BC] * (-0.05 * [N] + 1.05) * (0.7 * [T] + 0.3)' %>"
                  type="text" class="form-control" name="eval_comp_score" id="eval_comp_score_formula"
                  aria-describedby="formulaHelp" placeholder="Enter formula">
                <small id="formulaHelp" class="form-text text-muted">[BC] = base score, [N] = number of runs,
                  [T] = time left, starting from 1, approaching to 0
                </small>
              </div>
              <div class="row">
                <div class="col-1">
                  <input id="bc" type="text" class="form-control" placeholder="[BC]">
                </div>
                <div class="col-1">
                  <input id="n" type="text" class="form-control" placeholder="[N]">
                </div>
                <div class="col-1">
                  <input id="t" type="text" class="form-control" placeholder="[T]">
                </div>
                <button id="run-formula" type="button" class="btn btn-info" disabled>Run</button>

                <input id="preview" type="text" placeholder="" readonly style="border: 0px;" />
              </div>
              <!--                    <button id="validate-formula" type="button" class="btn btn-success">Validate</button>-->
            </div>
          </div>
        </div>
        <% } %>
          <% if (test.fixed_questions===true && test.type_name !=='Peer assessment PHASE2 MASTER' ) { %>
            <div id="divTestQuestions">
              <%- include(`${locals.partialsRoot}/testQuestions`) %>
            </div>
            <% } else if (test.fixed_questions===false){ %>
              <div id="divTestParts">
                <%- include(`${locals.partialsRoot}/testParts`) %>
              </div>
              <% } %>
</form>
<hr />
<% if (test.fixed_questions===true) { %>
  <div class="container-fluid">
    <div class="card card-body">
      <h4 class="card-title">Add questions</h4>
      <form id="frmQuestions" action="/test/def/question/list" method="GET">
        <input type="hidden" name="id_test" value="<%=test.id%>" />
        <div class="row">
          <div class="col-4">
            <label for="id_node">Node</label>
            <% locals.combodata={id: "id_node" , list: node_name, name: "id_node" }; %>
              <%- include(`${locals.partialsRoot}/combo`) %>
          </div>
          <div class="col-6">
            <label for="question_text">Text</label>
            <input type="text" class="form-control" id="question_text" name="question_text" />
          </div>
          <div class="col-2 d-flex align-items-end justify-content-end">
            <button id="btnFetchQuestions" type="submit" class="btn btn-secondary btn-outline">Fetch</button>
          </div>
      </form>
    </div>
  </div>
  <div id="divQuestions"></div>
  <% } else { %>
    <div class="container-fluid">
      <div class="card card-body">
        <h4 class="card-title">Add nodes</h4>
        <form id="frmNodes" action="/test/def/node/list" method="GET">
          <div class="row">
            <div class="col-4">
              <label for="id_node_type">Node type</label>
              <% locals.combodata={id: "id_node_type" , list: node_type, name: "id_node_type" }; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
            </div>
            <div class="col-6">
              <label for="node_name">Filter name</label>
              <input type="text" class="form-control" id="node_name" name="node_name" />
            </div>
            <div class="col-2 d-flex align-items-end justify-content-end">
              <button id="btnFetchNodes" type="submit" class="btn btn-primary">Fetch nodes</button>
            </div>

          </div>
        </form>
      </div>
    </div>
    <div id="divNodes"></div>
    <% } %>


      <% if (test.type_name==='Peer assessment PHASE2 MASTER' ) { %>
        <%- include(`./editPeerPhase2DefView2`) %>
          <% } %>
